SystemOrganization addCategory: #'PVpub-AnalogClockPrototype06'!

CircleMorph subclass: #Dial06
	instanceVariableNames: 'boundsLag watchhand06'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PVpub-AnalogClockPrototype06'!

!Dial06 commentStamp: '<historical>' prior: 0!
A Dial04 is a dial with a (invisible) midnight watchhand plus a (visible) watchhand.

Instance Variables
	watchHand03:		<Object>
	watchHand03s:		<Object>

watchHand03
	- xxxxx

watchHand03s
	- xxxxx
!

!Dial06 methodsFor: 'drawing' stamp: 'pv 12/27/2013 16:32'!
drawOn: aCanvas 
	| currentExtent oldExtent |
	currentExtent := self bounds corner - self bounds origin.
	oldExtent := boundsLag corner - boundsLag origin.
	currentExtent ~= oldExtent
		ifTrue: [self submorphs
				do: [:each | each step].
			boundsLag := self bounds].
	super drawOn: aCanvas! !

!Dial06 methodsFor: 'initialization' stamp: 'pv 12/27/2013 17:55'!
initialize
	super initialize.
	self extent: 200 @ 200;
		 position: 300 @ 300;
		 layoutPolicy: ConcentricLayout new.
	watchhand06 := Watchhand06 new.
	watchhand06
		setInitialMidnightVerticesFromCenter: self center
		andRadius: self extent x / 2
		withFraction: 0.9;
		 getEmbeddedInto: self.
	boundsLag := 1 @ 1 corner: 2 @ 2! !

PolygonMorph subclass: #Watchhand06
	instanceVariableNames: 'midnightVertices watchhand06Midnight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PVpub-AnalogClockPrototype06'!

!Watchhand06 commentStamp: 'pv 12/27/2013 16:31' prior: 0!
A Watchhand06 is a resizeable watchhand. It has a member watchhand06Midnight which represents a watchhand in midnight position.

Instance Variables
!

!Watchhand06 class methodsFor: 'geometry' stamp: 'pv 12/27/2013 14:50'!
inDegrees: aTime 
	"080413 should be a class method."
	| timeValue delta |
	delta := 0.0.
	timeValue := (aTime perform: #seconds) asFloat.
	^ 360 * timeValue / 60! !

!Watchhand06 methodsFor: 'initialization' stamp: 'pv 12/27/2013 17:55'!
getEmbeddedInto: aMorph 
	aMorph
		addMorph: watchhand06Midnight
		fullFrame: (LayoutConcentricFrame
				left: 0.3
				right: 0.3
				top: 0.9
				bottom: 0.3).
	watchhand06Midnight visible: false.
	aMorph addMorph: self! !

!Watchhand06 methodsFor: 'initialization' stamp: 'pv 12/27/2013 16:37'!
initialize
	super initialize.
	watchhand06Midnight := PolygonMorph new! !

!Watchhand06 methodsFor: 'geometry' stamp: 'pv 12/27/2013 14:50'!
rotationDegreesFromMidnightPosition: degrees 
	| flex center |
	(center := self valueOfProperty: #referencePosition)
		ifNil: [self setProperty: #referencePosition toValue: (center := self bounds center)].
	flex := (MorphicTransform offset: center negated)
				withAngle: degrees  degreesToRadians.
	self
		setVertices: (vertices
				collect: [:v | (flex transform: v)
						- flex offset]).
	self forwardDirection: degrees! !

!Watchhand06 methodsFor: 'initialization' stamp: 'pv 12/27/2013 16:48'!
setInitialMidnightVerticesFromCenter: aPoint andRadius: aFloat withFraction: aFractionFloat 
	"2013-09-29pv: vertices sind immer Float"
	| lozengeLengthFromCenter lozengeWidthFromCenter |
	lozengeLengthFromCenter := 3 max: aFloat * aFractionFloat.
	lozengeWidthFromCenter := 1 max: aFloat * (aFractionFloat / 3).
	midnightVertices := Array
				with: aPoint + (0 @ lozengeWidthFromCenter)
				with: aPoint + (-1 * lozengeWidthFromCenter @ 0)
				with: aPoint + (0 @ -1 * lozengeLengthFromCenter)
				with: aPoint + (lozengeWidthFromCenter @ 0).
	watchhand06Midnight setVertices: midnightVertices! !

!Watchhand06 methodsFor: 'stepping and presenter' stamp: 'pv 12/27/2013 16:39'!
step
	vertices := watchhand06Midnight vertices.
	self setRotationCenterFrom: owner center.
	self
		rotationDegreesFromMidnightPosition: (self class inDegrees: DateAndTime now)! !

!Watchhand06 methodsFor: 'stepping and presenter' stamp: 'pv 12/27/2013 14:50'!
stepTime
	^ 1000! !
